// Datei: infrarot.c
//
// Programm zum Rechenbeispiel des Infrarotsenders
//
// hk@holger-klabunde.de
// www.holger-klabunde.de
// 03.05.2002
// Compiler CC5x

#include <16F628.h>
#include <inline.h>

// Watchdog off, Power up Timer on, XT Oscillator, kein Code Protect
#pragma config |=0x3F61

//*******************************************************
// Hauptprogramm
//*******************************************************
void main()
{
 unsigned char i;
 
 CMCON=0b00000111;  //Comparator inaktiv

 CLRWDT;
 //Takt des PIC 4MHz, ein Zyklus = 1us
 OPTION=0b11000001; //Pullups off,Prescaler auf TMR0, 1:4

 TRISB=0b00000000;  //0=Ausgang, 1=Eingang
 TRISA=0b00000;     //0=Ausgang, 1=Eingang
 PORTB=0b00000000;  //Port einmal schreiben
 PORTA=0b00000000;  //Port einmal schreiben
 

 T2CON=0b00000100; //Pre- und Postscaler 1:1, Timer2 an
 CCP1CON=0b00001100; //PWM Modul an, Bit5:4 = 0

 PR2=27;      //ergibt PWM Frequenz 35,71kHz bei 4MHz und Prescaler 1:1
 CCPR1L=14;   //Duty Cycle 50% bei 6,8Bit Auflsung bzw. 112 Schritte

 while(1) // Programm-Endlosschleife
  {
   //Ab hier endlose Ausgabe vom 36kHz Signal
  } //while(1) Endlosschleife
}
