// Datei: Sinus.c
//
// Erzeugt einen Sinus mit 433Hz per PWM. Pegel fast 5Vss.
// Der Sinus ist noch ein bichen verzerrt. Das kann man
// ndern indem mehr Werte fr die Kurve benutzt werden.
// Dann ndert sich aber auch die Frequenz !
// Fsinus= 15,625kHz / Anzahl Samples 
//
//	Filter Diagram:
//		
//	           4k7             4k7	
//	RB3  ___/\  /\  /\______/\  /\  /\________ Analog Output
//	          \/  \/    |     \/  \/     |  
//	                    |                |
//	                  ----- 15nF       ----- 15nF
//	                  -----            -----
//	                    |                |
//	                   GND              GND
//
//
// hk@holger-klabunde.de
// www.holger-klabunde.de
// 05.05.2002
// Compiler CC5X

#include <16F628.h>
#include <inline.h>

// Watchdog off, Power up Timer on, XT Oscillator, kein Code Protect
#pragma config |=0x3F61

#include "interupt.c"

//*******************************************************
// Hauptprogramm
//*******************************************************
void main()
{
 CMCON=0b00000111;  //Comparator inaktiv

 CLRWDT;
 //Takt des PIC 4MHz, ein Zyklus = 1us
 OPTION=0b11000001; //Pullups off,Prescaler auf TMR0, 1:4

 TRISB=0b00000000;  //0=Ausgang, 1=Eingang
 TRISA=0b00000;     //0=Ausgang, 1=Eingang
 PORTB=0b00000000;  //Port einmal schreiben
 PORTA=0b00000000;  //Port einmal schreiben

 CCPR1L=0x20;        //2,5V Nullpunkt
 CCP1CON=0b00001111; //PWM-Mode
 PR2=63;             //Frequenz PWM 15,6kHz
 shapecount=0;
 
 //Interrupts erlauben
 GIE=1;
 PEIE=1;           //Peripheral Interrupts an
 TMR2IE=1;         //TMR2 to PR2 Match Interrupt an
 T2CON=0b00000100; //Prescaler 1:1, TMR2 on

 while(1) // Programm-Endlosschleife
  {
   //Der Rest luft per Interrupt
   //Ein Dauersinus wird ausgegeben
  } //while(1) Endlosschleife
  
}
